Index: libstdc++-v3/include/bits/locale_conv.h
===================================================================
--- libstdc++-v3/include/bits/locale_conv.h	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ libstdc++-v3/include/bits/locale_conv.h	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -51,7 +51,114 @@
    * @{
    */
 
+  template<typename _OutStr, typename _InChar, typename _Codecvt,
+	   typename _State, typename _Fn>
+    bool
+    __do_str_codecvt(const _InChar* __first, const _InChar* __last,
+		     _OutStr& __outstr, const _Codecvt& __cvt, _State& __state,
+		     size_t& __count, _Fn __fn)
+    {
+      if (__first == __last)
+	{
+	  __outstr.clear();
+	  __count = 0;
+	  return true;
+	}
+
+      size_t __outchars = 0;
+      auto __next = __first;
+      const auto __maxlen = __cvt.max_length() + 1;
+
+      codecvt_base::result __result;
+      do
+	{
+	  __outstr.resize(__outstr.size() + (__last - __next) * __maxlen);
+	  auto __outnext = &__outstr.front() + __outchars;
+	  auto const __outlast = &__outstr.back() + 1;
+	  __result = (__cvt.*__fn)(__state, __next, __last, __next,
+					__outnext, __outlast, __outnext);
+	  __outchars = __outnext - &__outstr.front();
+	}
+      while (__result == codecvt_base::partial && __next != __last
+	     && (__outstr.size() - __outchars) < __maxlen);
+
+      if (__result == codecvt_base::error)
+	return false;
+
+      if (__result == codecvt_base::noconv)
+	{
+	  __outstr.assign(__first, __last);
+	  __count = __last - __first;
+	}
+      else
+	{
+	  __outstr.resize(__outchars);
+	  __count = __next - __first;
+	}
+
+      return true;
+    }
+
+  // Convert narrow character string to wide.
+  template<typename _CharT, typename _Traits, typename _Alloc, typename _State>
+    inline bool
+    __str_codecvt_in(const char* __first, const char* __last,
+		     basic_string<_CharT, _Traits, _Alloc>& __outstr,
+		     const codecvt<_CharT, char, _State>& __cvt,
+		     _State& __state, size_t& __count)
+    {
+      using _Codecvt = codecvt<_CharT, char, _State>;
+      using _ConvFn
+	= codecvt_base::result
+	  (_Codecvt::*)(_State&, const char*, const char*, const char*&,
+			_CharT*, _CharT*, _CharT*&) const;
+      _ConvFn __fn = &codecvt<_CharT, char, _State>::in;
+      return __do_str_codecvt(__first, __last, __outstr, __cvt, __state,
+			      __count, __fn);
+    }
+
+  template<typename _CharT, typename _Traits, typename _Alloc, typename _State>
+    inline bool
+    __str_codecvt_in(const char* __first, const char* __last,
+		     basic_string<_CharT, _Traits, _Alloc>& __outstr,
+		     const codecvt<_CharT, char, _State>& __cvt)
+    {
+      _State __state = {};
+      size_t __n;
+      return __str_codecvt_in(__first, __last, __outstr, __cvt, __state, __n);
+    }
+
+  // Convert wide character string to narrow.
+  template<typename _CharT, typename _Traits, typename _Alloc, typename _State>
+    inline bool
+    __str_codecvt_out(const _CharT* __first, const _CharT* __last,
+		      basic_string<char, _Traits, _Alloc>& __outstr,
+		      const codecvt<_CharT, char, _State>& __cvt,
+		      _State& __state, size_t& __count)
+    {
+      using _Codecvt = codecvt<_CharT, char, _State>;
+      using _ConvFn
+	= codecvt_base::result
+	  (_Codecvt::*)(_State&, const _CharT*, const _CharT*, const _CharT*&,
+			char*, char*, char*&) const;
+      _ConvFn __fn = &codecvt<_CharT, char, _State>::out;
+      return __do_str_codecvt(__first, __last, __outstr, __cvt, __state,
+			      __count, __fn);
+    }
+
+  template<typename _CharT, typename _Traits, typename _Alloc, typename _State>
+    inline bool
+    __str_codecvt_out(const _CharT* __first, const _CharT* __last,
+		      basic_string<char, _Traits, _Alloc>& __outstr,
+		      const codecvt<_CharT, char, _State>& __cvt)
+    {
+      _State __state = {};
+      size_t __n;
+      return __str_codecvt_out(__first, __last, __outstr, __cvt, __state, __n);
+    }
+
 _GLIBCXX_BEGIN_NAMESPACE_CXX11
+
   /// String conversions
   template<typename _Codecvt, typename _Elem = wchar_t,
 	   typename _Wide_alloc = allocator<_Elem>,
@@ -137,9 +244,15 @@
       wide_string
       from_bytes(const char* __first, const char* __last)
       {
-	auto __errstr = _M_with_strings ? &_M_wide_err_string : nullptr;
-	_ConvFn<char, _Elem> __fn = &_Codecvt::in;
-	return _M_conv(__first, __last, __errstr, __fn);
+	if (!_M_with_cvtstate)
+	  _M_state = state_type();
+	wide_string __out{ _M_wide_err_string.get_allocator() };
+	if (__str_codecvt_in(__first, __last, __out, *_M_cvt, _M_state,
+			     _M_count))
+	  return __out;
+	if (_M_with_strings)
+	  return _M_wide_err_string;
+	__throw_range_error("wstring_convert::from_bytes");
       }
       /// @}
 
@@ -167,9 +280,15 @@
       byte_string
       to_bytes(const _Elem* __first, const _Elem* __last)
       {
-	auto __errstr = _M_with_strings ? &_M_byte_err_string : nullptr;
-	_ConvFn<_Elem, char> __fn = &_Codecvt::out;
-	return _M_conv(__first, __last, __errstr, __fn);
+	if (!_M_with_cvtstate)
+	  _M_state = state_type();
+	byte_string __out{ _M_byte_err_string.get_allocator() };
+	if (__str_codecvt_out(__first, __last, __out, *_M_cvt, _M_state,
+			      _M_count))
+	  return __out;
+	if (_M_with_strings)
+	  return _M_byte_err_string;
+	__throw_range_error("wstring_convert::to_bytes");
       }
       /// @}
 
@@ -182,63 +301,6 @@
       state_type state() const { return _M_state; }
 
     private:
-      template<typename _InC, typename _OutC>
-	using _ConvFn
-	  = codecvt_base::result
-	    (_Codecvt::*)(state_type&, const _InC*, const _InC*, const _InC*&,
-			  _OutC*, _OutC*, _OutC*&) const;
-
-      template<typename _InChar, typename _OutStr, typename _MemFn>
-	_OutStr
-	_M_conv(const _InChar* __first, const _InChar* __last,
-		const _OutStr* __err, _MemFn __memfn)
-	{
-	  auto __outstr = __err ? _OutStr(__err->get_allocator()) : _OutStr();
-
-	  if (__first == __last)
-	    {
-	      _M_count = 0;
-	      return __outstr;
-	    }
-
-	  if (!_M_with_cvtstate)
-	    _M_state = state_type();
-
-	  size_t __outchars = 0;
-	  auto __next = __first;
-	  const auto __maxlen = _M_cvt->max_length() + 1;
-
-	  codecvt_base::result __result;
-	  do
-	    {
-	      __outstr.resize(__outstr.size() + (__last - __next) * __maxlen);
-	      auto __outnext = &__outstr.front() + __outchars;
-	      auto const __outlast = &__outstr.back() + 1;
-	      __result = ((*_M_cvt).*__memfn)(_M_state, __next, __last, __next,
-					    __outnext, __outlast, __outnext);
-	      __outchars = __outnext - &__outstr.front();
-	    }
-	  while (__result == codecvt_base::partial && __next != __last
-		 && (__outstr.size() - __outchars) < __maxlen);
-
-	  if (__result == codecvt_base::noconv)
-	    {
-	      __outstr.assign(__first, __last);
-	      _M_count = __outstr.size();
-	      return __outstr;
-	    }
-
-	  __outstr.resize(__outchars);
-	  _M_count = __next - __first;
-
-	  if (__result != codecvt_base::error)
-	    return __outstr;
-	  else if (__err)
-	    return *__err;
-	  else
-	    __throw_range_error("wstring_convert");
-	}
-
       unique_ptr<_Codecvt>	_M_cvt;
       byte_string		_M_byte_err_string;
       wide_string		_M_wide_err_string;
@@ -247,6 +309,7 @@
       bool			_M_with_cvtstate = false;
       bool			_M_with_strings = false;
     };
+
 _GLIBCXX_END_NAMESPACE_CXX11
 
   /// Buffer conversions
Index: libstdc++-v3/include/bits/atomic_futex.h
===================================================================
--- libstdc++-v3/include/bits/atomic_futex.h	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ libstdc++-v3/include/bits/atomic_futex.h	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -93,15 +93,15 @@
     {
       for (;;)
 	{
-	  // Don't bother checking the value again because we expect the caller to
-	  // have done it recently.
+	  // Don't bother checking the value again because we expect the caller
+	  // to have done it recently.
 	  // memory_order_relaxed is sufficient because we can rely on just the
 	  // modification order (store_notify uses an atomic RMW operation too),
 	  // and the futex syscalls synchronize between themselves.
 	  _M_data.fetch_or(_Waiter_bit, memory_order_relaxed);
-	  bool __ret;
-	  __ret = _M_futex_wait_until((unsigned*)(void*)&_M_data,
-	      __assumed | _Waiter_bit, __has_timeout, __s, __ns);
+	  bool __ret = _M_futex_wait_until((unsigned*)(void*)&_M_data,
+					   __assumed | _Waiter_bit,
+					   __has_timeout, __s, __ns);
 	  // Fetch the current value after waiting (clears _Waiter_bit).
 	  __assumed = _M_load(__mo);
 	  if (!__ret || ((__operand == __assumed) == __equal))
@@ -119,7 +119,7 @@
 	bool __equal, memory_order __mo)
     {
       return _M_load_and_test_until(__assumed, __operand, __equal, __mo,
-	  false, chrono::seconds(0), chrono::nanoseconds(0));
+				    false, {}, {});
     }
 
     // If a timeout occurs, returns a current value after the timeout;
@@ -146,7 +146,8 @@
     _M_load_when_not_equal(unsigned __val, memory_order __mo)
     {
       unsigned __i = _M_load(__mo);
-      if ((__i & ~_Waiter_bit) != __val) return;
+      if ((__i & ~_Waiter_bit) != __val)
+	return (__i & ~_Waiter_bit);
       // TODO Spin-wait first.
       return _M_load_and_test(__i, __val, false, __mo);
     }
Index: libstdc++-v3/include/bits/regex_scanner.tcc
===================================================================
--- libstdc++-v3/include/bits/regex_scanner.tcc	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ libstdc++-v3/include/bits/regex_scanner.tcc	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -99,6 +99,12 @@
       auto __c = *_M_current++;
       const char* __pos;
 
+      if (std::strchr(_M_spec_char, _M_ctype.narrow(__c, '\0')) == nullptr)
+	{
+	  _M_token = _S_token_ord_char;
+	  _M_value.assign(1, __c);
+	  return;
+	}
       if (__c == '\\')
 	{
 	  if (_M_current == _M_end)
Index: libstdc++-v3/include/bits/quoted_string.h
===================================================================
--- libstdc++-v3/include/bits/quoted_string.h	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ libstdc++-v3/include/bits/quoted_string.h	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,164 @@
+// Helpers for quoted stream manipulators -*- C++ -*-
+
+// Copyright (C) 2013-2015 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// Under Section 7 of GPL version 3, you are granted additional
+// permissions described in the GCC Runtime Library Exception, version
+// 3.1, as published by the Free Software Foundation.
+
+// You should have received a copy of the GNU General Public License and
+// a copy of the GCC Runtime Library Exception along with this program;
+// see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
+// <http://www.gnu.org/licenses/>.
+
+/** @file bits/quoted_string.h
+ *  This is an internal header file, included by other library headers.
+ *  Do not attempt to use it directly. @headername{iomanip}
+ */
+
+#ifndef _GLIBCXX_QUOTED_STRING_H
+#define _GLIBCXX_QUOTED_STRING_H 1
+
+#pragma GCC system_header
+
+#if __cplusplus < 201103L
+# include <bits/c++0x_warning.h>
+#else
+#include <sstream>
+
+namespace std _GLIBCXX_VISIBILITY(default)
+{
+  namespace __detail {
+  _GLIBCXX_BEGIN_NAMESPACE_VERSION
+
+    /**
+     * @brief Struct for delimited strings.
+     */
+    template<typename _String, typename _CharT>
+      struct _Quoted_string
+      {
+	static_assert(is_reference<_String>::value
+		   || is_pointer<_String>::value,
+		      "String type must be pointer or reference");
+
+	_Quoted_string(_String __str, _CharT __del, _CharT __esc)
+	: _M_string(__str), _M_delim{__del}, _M_escape{__esc}
+	{ }
+
+	_Quoted_string&
+	operator=(_Quoted_string&) = delete;
+
+	_String _M_string;
+	_CharT _M_delim;
+	_CharT _M_escape;
+      };
+
+    /**
+     * @brief Inserter for quoted strings.
+     *
+     *  _GLIBCXX_RESOLVE_LIB_DEFECTS
+     *  DR 2344 quoted()'s interaction with padding is unclear
+     */
+    template<typename _CharT, typename _Traits>
+      std::basic_ostream<_CharT, _Traits>&
+      operator<<(std::basic_ostream<_CharT, _Traits>& __os,
+		 const _Quoted_string<const _CharT*, _CharT>& __str)
+      {
+	std::basic_ostringstream<_CharT, _Traits> __ostr;
+	__ostr << __str._M_delim;
+	for (const _CharT* __c = __str._M_string; *__c; ++__c)
+	  {
+	    if (*__c == __str._M_delim || *__c == __str._M_escape)
+	      __ostr << __str._M_escape;
+	    __ostr << *__c;
+	  }
+	__ostr << __str._M_delim;
+
+	return __os << __ostr.str();
+      }
+
+    /**
+     * @brief Inserter for quoted strings.
+     *
+     *  _GLIBCXX_RESOLVE_LIB_DEFECTS
+     *  DR 2344 quoted()'s interaction with padding is unclear
+     */
+    template<typename _CharT, typename _Traits, typename _String>
+      std::basic_ostream<_CharT, _Traits>&
+      operator<<(std::basic_ostream<_CharT, _Traits>& __os,
+		 const _Quoted_string<_String, _CharT>& __str)
+      {
+	std::basic_ostringstream<_CharT, _Traits> __ostr;
+	__ostr << __str._M_delim;
+	for (auto& __c : __str._M_string)
+	  {
+	    if (__c == __str._M_delim || __c == __str._M_escape)
+	      __ostr << __str._M_escape;
+	    __ostr << __c;
+	  }
+	__ostr << __str._M_delim;
+
+	return __os << __ostr.str();
+      }
+
+    /**
+     * @brief Extractor for delimited strings.
+     *        The left and right delimiters can be different.
+     */
+    template<typename _CharT, typename _Traits, typename _Alloc>
+      std::basic_istream<_CharT, _Traits>&
+      operator>>(std::basic_istream<_CharT, _Traits>& __is,
+		 const _Quoted_string<basic_string<_CharT, _Traits, _Alloc>&,
+				      _CharT>& __str)
+      {
+	_CharT __c;
+	__is >> __c;
+	if (!__is.good())
+	  return __is;
+	if (__c != __str._M_delim)
+	  {
+	    __is.unget();
+	    __is >> __str._M_string;
+	    return __is;
+	  }
+	__str._M_string.clear();
+	std::ios_base::fmtflags __flags
+	  = __is.flags(__is.flags() & ~std::ios_base::skipws);
+	do
+	  {
+	    __is >> __c;
+	    if (!__is.good())
+	      break;
+	    if (__c == __str._M_escape)
+	      {
+		__is >> __c;
+		if (!__is.good())
+		  break;
+	      }
+	    else if (__c == __str._M_delim)
+	      break;
+	    __str._M_string += __c;
+	  }
+	while (true);
+	__is.setf(__flags);
+
+	return __is;
+      }
+
+  _GLIBCXX_END_NAMESPACE_VERSION
+  } // namespace __detail
+} // namespace std
+
+#endif // C++11
+#endif /* _GLIBCXX_QUOTED_STRING_H */
Index: libstdc++-v3/include/bits/range_access.h
===================================================================
--- libstdc++-v3/include/bits/range_access.h	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ libstdc++-v3/include/bits/range_access.h	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -98,6 +98,14 @@
     { return __arr + _Nm; }
 
 #if __cplusplus >= 201402L
+
+  template<typename _Tp> class valarray;
+  // These overloads must be declared for cbegin and cend to use them.
+  template<typename _Tp> _Tp* begin(valarray<_Tp>&);
+  template<typename _Tp> const _Tp* begin(const valarray<_Tp>&);
+  template<typename _Tp> _Tp* end(valarray<_Tp>&);
+  template<typename _Tp> const _Tp* end(const valarray<_Tp>&);
+
   /**
    *  @brief  Return an iterator pointing to the first element of
    *          the const container.
Index: libstdc++-v3/include/bits/regex_compiler.tcc
===================================================================
--- libstdc++-v3/include/bits/regex_compiler.tcc	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ libstdc++-v3/include/bits/regex_compiler.tcc	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -424,8 +424,7 @@
 	    __last_char.first = true;
 	    __last_char.second = _M_value[0];
 	  }
-      while (!_M_match_token(_ScannerT::_S_token_bracket_end))
-	_M_expression_term(__last_char, __matcher);
+      while (_M_expression_term(__last_char, __matcher));
       __matcher._M_ready();
       _M_stack.push(_StateSeqT(
 		      *_M_nfa,
@@ -434,21 +433,31 @@
 
   template<typename _TraitsT>
   template<bool __icase, bool __collate>
-    void
+    bool
     _Compiler<_TraitsT>::
     _M_expression_term(pair<bool, _CharT>& __last_char,
 		       _BracketMatcher<_TraitsT, __icase, __collate>& __matcher)
     {
+      if (_M_match_token(_ScannerT::_S_token_bracket_end))
+	return false;
+
       if (_M_match_token(_ScannerT::_S_token_collsymbol))
-	__matcher._M_add_collating_element(_M_value);
+	{
+	  auto __symbol = __matcher._M_add_collate_element(_M_value);
+	  if (__symbol.size() == 1)
+	    {
+	      __last_char.first = true;
+	      __last_char.second = __symbol[0];
+	    }
+	}
       else if (_M_match_token(_ScannerT::_S_token_equiv_class_name))
 	__matcher._M_add_equivalence_class(_M_value);
       else if (_M_match_token(_ScannerT::_S_token_char_class_name))
 	__matcher._M_add_character_class(_M_value, false);
-      // POSIX doesn't permit '-' as a start-range char (say [a-z--0]),
-      // except when the '-' is the first character in the bracket expression
-      // ([--0]). ECMAScript treats all '-' after a range as a normal character.
-      // Also see above, where _M_expression_term gets called.
+      // POSIX doesn't allow '-' as a start-range char (say [a-z--0]),
+      // except when the '-' is the first or last character in the bracket
+      // expression ([--0]). ECMAScript treats all '-' after a range as a
+      // normal character. Also see above, where _M_expression_term gets called.
       //
       // As a result, POSIX rejects [-----], but ECMAScript doesn't.
       // Boost (1.57.0) always uses POSIX style even in its ECMAScript syntax.
@@ -459,10 +468,14 @@
 	{
 	  if (!__last_char.first)
 	    {
+	      __matcher._M_add_char(_M_value[0]);
 	      if (_M_value[0] == '-'
 		  && !(_M_flags & regex_constants::ECMAScript))
-		__throw_regex_error(regex_constants::error_range);
-	      __matcher._M_add_char(_M_value[0]);
+		{
+		  if (_M_match_token(_ScannerT::_S_token_bracket_end))
+		    return false;
+		  __throw_regex_error(regex_constants::error_range);
+		}
 	      __last_char.first = true;
 	      __last_char.second = _M_value[0];
 	    }
@@ -496,6 +509,8 @@
 						     _M_value[0]));
       else
 	__throw_regex_error(regex_constants::error_brack);
+
+      return true;
     }
 
   template<typename _TraitsT>
Index: libstdc++-v3/include/Makefile.am
===================================================================
--- libstdc++-v3/include/Makefile.am	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ libstdc++-v3/include/Makefile.am	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -128,6 +128,7 @@
 	${bits_srcdir}/postypes.h \
 	${bits_srcdir}/predefined_ops.h \
 	${bits_srcdir}/ptr_traits.h \
+	${bits_srcdir}/quoted_string.h \
 	${bits_srcdir}/random.h \
 	${bits_srcdir}/random.tcc \
 	${bits_srcdir}/range_access.h \
@@ -650,11 +651,23 @@
 	${experimental_srcdir}/optional \
 	${experimental_srcdir}/ratio \
 	${experimental_srcdir}/string_view \
+	${experimental_srcdir}/string_view.tcc \
 	${experimental_srcdir}/system_error \
-	${experimental_srcdir}/string_view.tcc \
 	${experimental_srcdir}/tuple \
-	${experimental_srcdir}/type_traits
+	${experimental_srcdir}/type_traits \
+	${experimental_filesystem_headers}
 
+if ENABLE_FILESYSTEM_TS
+experimental_filesystem_headers = \
+	${experimental_srcdir}/filesystem \
+	${experimental_srcdir}/fs_dir.h \
+	${experimental_srcdir}/fs_fwd.h \
+	${experimental_srcdir}/fs_ops.h \
+	${experimental_srcdir}/fs_path.h
+else
+experimental_filesystem_headers =
+endif
+
 # This is the common subset of C++ files that all three "C" header models use.
 c_base_srcdir = $(C_INCLUDE_DIR)
 c_base_builddir = .
Index: libstdc++-v3/libsupc++/eh_ptr.cc
===================================================================
--- libstdc++-v3/libsupc++/eh_ptr.cc	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ libstdc++-v3/libsupc++/eh_ptr.cc	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -245,6 +245,9 @@
   __GXX_INIT_DEPENDENT_EXCEPTION_CLASS(dep->unwindHeader.exception_class);
   dep->unwindHeader.exception_cleanup = __gxx_dependent_exception_cleanup;
 
+  __cxa_eh_globals *globals = __cxa_get_globals ();
+  globals->uncaughtExceptions += 1;
+
 #ifdef _GLIBCXX_SJLJ_EXCEPTIONS
   _Unwind_SjLj_RaiseException (&dep->unwindHeader);
 #else
Index: libstdc++-v3/ChangeLog
===================================================================
--- libstdc++-v3/ChangeLog	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ libstdc++-v3/ChangeLog	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -1,3 +1,190 @@
+2015-09-03  Jonathan Wakely  <jwakely@redhat.com>
+
+	* include/std/shared_mutex (shared_timed_mutex::shared_timed_mutex):
+	Replace throw with __throw_bad_alloc.
+
+	PR libstdc++/66998
+	* include/experimental/functional (_Not_fn): Add exception
+	specifications and non-deduced return types.
+	(not_fn): Add exception specification and wrap pointer-to-member.
+	* testsuite/experimental/functional/not_fn.cc: Test in SFINAE context
+	and test pointer-to-member.
+
+	Backport from mainline
+	2015-08-27  Jonathan Wakely  <jwakely@redhat.com>
+
+	PR libstdc++/67374
+	* include/bits/range_access.h (valarray, begin, end): Declare.
+	* testsuite/26_numerics/valarray/range_access.cc: Test const
+	overloads.
+	* testsuite/26_numerics/valarray/range_access2.cc: New.
+
+	Backport from mainline
+	2015-07-24  Jonathan Wakely  <jwakely@redhat.com>
+
+	* include/bits/atomic_futex.h [_GLIBCXX_HAVE_LINUX_FUTEX]
+	(_M_load_and_test_until): Whitespace.
+	(_M_load_and_test): Value-initialize the unused durations.
+	(_M_load_when_equal): Add missing return value.
+
+	Backport from mainline
+	2015-07-13  Jonathan Wakely  <jwakely@redhat.com>
+
+	PR libstdc++/66855
+	* src/c++11/codecvt.cc (__codecvt_utf8_utf16_base::do_in): Override
+	endianness bit in mode.
+	* testsuite/22_locale/codecvt/codecvt_utf8_utf16/66855.cc: New.
+
+	Backport from mainline
+	2015-04-27  Dmitry Prokoptsev  <dprokoptsev@gmail.com>
+		    Michael Hanselmann  <public@hansmi.ch>
+
+	PR libstdc++/62258
+	* libsupc++/eh_ptr.cc (rethrow_exception): Increment count of
+	uncaught exceptions.
+	* testsuite/18_support/exception_ptr/62258.cc: New.
+
+2015-08-28  Tim Shen  <timshen@google.com>
+
+	Backport from mainline
+	2015-08-28  Tim Shen  <timshen@google.com>
+
+	PR libstdc++/67362
+	* include/bits/regex_scanner.tcc (_Scanner<>::_M_scan_normal):
+	Always returns ordinary char token if the char isn't
+	considered a special char.
+	* testsuite/28_regex/regression.cc: New test file for collecting
+	regression testcases from, typically, bugzilla.
+
+2015-08-20  Jonathan Wakely  <jwakely@redhat.com>
+
+	* python/Makefile.am: Ensure gdb.py is installed for libstdc++ not
+	libstdc++fs.
+	* python/Makefile.in: Regenerate.
+
+2015-08-18  Jonathan Wakely  <jwakely@redhat.com>
+
+	Backport Filesystem TS from mainline
+	* acinclude.m4 (GLIBCXX_ENABLE_FILESYSTEM_TS,
+	GLIBCXX_CHECK_FILESYSTEM_DEPS): Define.
+	* configure.ac: Use them.
+	* configure: Regenerate.
+	* config.h.in: Regenerate.
+	* include/Makefile.am: Add filesystem headers. Fix order of headers.
+	* include/Makefile.in: Regenerate.
+	* include/bits/locale_conv.h (__do_str_codecvt, __str_codecvt_in,
+	__str_codecvt_out, wstring_convert): Refactor to move all conversion
+	logic to non-member functions.
+	* include/bits/quoted_string.h (_Quoted_string, operator<<,
+	operator>>): Move from <iomanip> to new header.
+	* include/experimental/filesystem: New.
+	* include/experimental/fs_dir.h: New.
+	* include/experimental/fs_fwd.h: New.
+	* include/experimental/fs_ops.h: New.
+	* include/experimental/fs_path.h: New.
+	* include/std/iomanip (_Quoted_string, operator<<, operator>>): Move
+	to <bits/quoted_string.h>.
+	* libstdcxx/v6/printers.py (StdExpPathPrinter): Define.
+	* scripts/testsuite_flags.in: Add filesystem dir to ldflags.
+	* src/Makefile.am: Add filesystem sub-dir.
+	* src/Makefile.in: Regenerate.
+	* src/filesystem/Makefile.am: New.
+	* src/filesystem/Makefile.in: New.
+	* src/filesystem/dir.cc: New.
+	* src/filesystem/ops.cc: New.
+	* src/filesystem/path.cc: New.
+	* testsuite/experimental/filesystem/operations/absolute.cc: New.
+	* testsuite/experimental/filesystem/operations/copy.cc: New.
+	* testsuite/experimental/filesystem/operations/current_path.cc: New.
+	* testsuite/experimental/filesystem/operations/exists.cc: New.
+	* testsuite/experimental/filesystem/operations/file_size.cc: New.
+	* testsuite/experimental/filesystem/operations/status.cc: New.
+	* testsuite/experimental/filesystem/operations/temp_directory_path.cc:
+	New.
+	* testsuite/experimental/filesystem/path/append/path.cc: New.
+	* testsuite/experimental/filesystem/path/assign/assign.cc: New.
+	* testsuite/experimental/filesystem/path/assign/copy.cc: New.
+	* testsuite/experimental/filesystem/path/compare/compare.cc: New.
+	* testsuite/experimental/filesystem/path/compare/path.cc: New.
+	* testsuite/experimental/filesystem/path/compare/strings.cc: New.
+	* testsuite/experimental/filesystem/path/concat/path.cc: New.
+	* testsuite/experimental/filesystem/path/concat/strings.cc: New.
+	* testsuite/experimental/filesystem/path/construct/copy.cc: New.
+	* testsuite/experimental/filesystem/path/construct/default.cc: New.
+	* testsuite/experimental/filesystem/path/construct/locale.cc: New.
+	* testsuite/experimental/filesystem/path/construct/range.cc: New.
+	* testsuite/experimental/filesystem/path/decompose/extension.cc: New.
+	* testsuite/experimental/filesystem/path/decompose/filename.cc: New.
+	* testsuite/experimental/filesystem/path/decompose/parent_path.cc:
+	New.
+	* testsuite/experimental/filesystem/path/decompose/relative_path.cc:
+	New.
+	* testsuite/experimental/filesystem/path/decompose/root_directory.cc:
+	New.
+	* testsuite/experimental/filesystem/path/decompose/root_name.cc: New.
+	* testsuite/experimental/filesystem/path/decompose/root_path.cc: New.
+	* testsuite/experimental/filesystem/path/decompose/stem.cc: New.
+	* testsuite/experimental/filesystem/path/generic/generic_string.cc:
+	New.
+	* testsuite/experimental/filesystem/path/itr/traversal.cc: New.
+	* testsuite/experimental/filesystem/path/modifiers/clear.cc: New.
+	* testsuite/experimental/filesystem/path/modifiers/make_preferred.cc:
+	New.
+	* testsuite/experimental/filesystem/path/modifiers/remove_filename.cc:
+	New.
+	* testsuite/experimental/filesystem/path/modifiers/
+	replace_extension.cc: New.
+	* testsuite/experimental/filesystem/path/modifiers/replace_filename.cc:
+	New.
+	* testsuite/experimental/filesystem/path/modifiers/swap.cc: New.
+	* testsuite/experimental/filesystem/path/nonmember/hash_value.cc:
+	New.
+	* testsuite/experimental/filesystem/path/query/empty.cc: New.
+	* testsuite/experimental/filesystem/path/query/has_extension.cc: New.
+	* testsuite/experimental/filesystem/path/query/has_filename.cc: New.
+	* testsuite/experimental/filesystem/path/query/has_parent_path.cc:
+	New.
+	* testsuite/experimental/filesystem/path/query/has_relative_path.cc:
+	New.
+	* testsuite/experimental/filesystem/path/query/has_root_directory.cc:
+	New.
+	* testsuite/experimental/filesystem/path/query/has_root_name.cc: New.
+	* testsuite/experimental/filesystem/path/query/has_root_path.cc: New.
+	* testsuite/experimental/filesystem/path/query/has_stem.cc: New.
+	* testsuite/experimental/filesystem/path/query/is_relative.cc: New.
+	* testsuite/lib/dg-options.exp (dg-require-filesystem-ts): Define.
+	* testsuite/lib/libstdc++.exp (check_v3_target_filesystem_ts): Define.
+	* testsuite/util/testsuite_fs.h: New.
+
+2015-08-18  Jonathan Wakely  <jwakely@redhat.com>
+
+	* Makefile.in: Regenerate with automake-1.11.6.
+	* aclocal.m4: Likewise.
+	* configure: Likewise.
+	* doc/Makefile.in: Likewise.
+	* include/Makefile.in: Likewise.
+	* libsupc++/Makefile.in: Likewise.
+	* po/Makefile.in: Likewise.
+	* python/Makefile.in: Likewise.
+	* src/Makefile.in: Likewise.
+	* src/c++11/Makefile.in: Likewise.
+	* src/c++98/Makefile.in: Likewise.
+	* testsuite/Makefile.in: Likewise.
+
+2015-07-29  Tim Shen  <timshen@google.com>
+
+	Backport from mainline
+	2015-07-29  Tim Shen  <timshen@google.com>
+
+	PR libstdc++/67015
+	* include/bits/regex_compiler.h (_Compiler<>::_M_expression_term,
+	_BracketMatcher<>::_M_add_collating_element): Change signature
+	to make checking the and of bracket expression easier.
+	* include/bits/regex_compiler.tcc (_Compiler<>::_M_expression_term):
+	Treat '-' as a valid literal if it's at the end of bracket expression.
+	* testsuite/28_regex/algorithms/regex_match/cstring_bracket_01.cc:
+	New testcases.
+
 2015-07-16  Release Manager
 
 	* GCC 5.2.0 released.
Index: libstdc++-v3/testsuite/28_regex/regression.cc
===================================================================
--- libstdc++-v3/testsuite/28_regex/regression.cc	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ libstdc++-v3/testsuite/28_regex/regression.cc	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,42 @@
+// { dg-options "-std=gnu++11" }
+
+//
+// Copyright (C) 2015 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+//
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+#include <testsuite_hooks.h>
+#include <testsuite_regex.h>
+
+using namespace __gnu_test;
+using namespace std;
+
+// PR libstdc++/67362
+void
+test01()
+{
+  bool test __attribute__((unused)) = true;
+
+  regex re("((.)", regex_constants::basic);
+}
+
+int
+main()
+{
+  test01();
+  return 0;
+}
+
